#jinja2: trim_blocks: True, lstrip_blocks: True
{{ ansible_managed | comment }}
# http://prometheus.io/docs/operating/configuration/

global:
  {{ prometheus_global | to_nice_yaml(indent=2) | indent(2, False) }}
  external_labels:
    datacentre: '{{ prometheus_datacentre }}'

{% if prometheus_remote_write != [] %}
remote_write:
  {{ prometheus_remote_write | to_nice_yaml(indent=2) | indent(2, False) }}
{% endif %}

{% if prometheus_remote_read != [] %}
remote_read:
  {{ prometheus_remote_read | to_nice_yaml(indent=2) | indent(2, False) }}
{% endif %}

rule_files:
  - {{ prometheus_server_config_dir }}/rules/*.rules

{% if prometheus_alertmanager_config | length > 0 %}
alerting:
  alertmanagers:
  {{ prometheus_alertmanager_config | to_nice_yaml(indent=2) | indent(2,False) }}
  alert_relabel_configs:
{% if prometheus_static_node_metric_relabel_configs | length > 0 %}
  # prometheus_static_node_metric_relabel_configs
  {{ prometheus_static_node_metric_relabel_configs | to_nice_yaml(indent=2) | indent(2,False) }}
{% endif %}
{% if prometheus_elasticsearch_instance_add_cluster_label | length > 0 %}
  # prometheus_elasticsearch_instance_add_cluster_label
  {{ prometheus_elasticsearch_instance_add_cluster_label | to_nice_yaml(indent=2) | indent(2,False) }}
{% endif %}
{% if prometheus_node_metric_relabel_configs | length > 0 %}
  # prometheus_node_metric_relabel_configs
  {{ prometheus_node_metric_relabel_configs | to_nice_yaml(indent=2) | indent(2,False) }}
{% endif %}
{% endif %}

scrape_configs:
  {{ prometheus_scrape_configs | to_nice_yaml(indent=2) | indent(2,False) }}

{% if prometheus_openstack_exporter_addr | length > 0 %}
  - job_name: "openstack_exporter"
    scrape_interval: 60s
    scrape_timeout: 45s
    honor_labels: true
    static_configs:
      - targets:
        - "{{ prometheus_openstack_exporter_addr }}"
{% endif %}

{% if kubeconfig %}

{% for cluster in prometheus_k8s_clusters %}
# https://github.com/prometheus/prometheus/blob/master/documentation/examples/prometheus-kubernetes.yml
  - job_name: 'kube-apiserver-{{ cluster.prometheus_datacentre }}'
    kubernetes_sd_configs:
    - role: endpoints
      api_server: "{{ cluster.api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: {{ cluster.client_certificate }}
      bearer_token_file: {{ cluster.bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      ca_file: {{ cluster.client_certificate }}
    bearer_token_file: {{ cluster.bearer_token }}
    relabel_configs:
    - source_labels: [__meta_kubernetes_namespace, __meta_kubernetes_service_name, __meta_kubernetes_endpoint_port_name]
      action: keep
      regex: default;kubernetes;https
    - source_labels: ['__name__']
      regex: '.*'
      action: replace
      target_label: 'datacentre'
      replacement: "{{ cluster.prometheus_datacentre }}"
    - source_labels: ['__name__']
      regex: '.*'
      action: replace
      target_label: 'job'
      replacement: "kube-apiserver"

  - job_name: 'kubelet-{{ cluster.prometheus_datacentre }}'
    kubernetes_sd_configs:
    - role: node
      api_server: "{{ cluster.api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: {{ cluster.client_certificate }}
      bearer_token_file: {{ cluster.bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      insecure_skip_verify: true
    bearer_token_file: {{ cluster.bearer_token }}
    metric_relabel_configs:
    - action: labelmap
      regex: __meta_kubernetes_node_label_(.+)
    - target_label: __address__
      replacement: kubernetes.default.svc:443
    - source_labels: [__meta_kubernetes_node_name]
      regex: (.+)
      target_label: __metrics_path__
      replacement: /api/v1/nodes/${1}/proxy/metrics
    relabel_configs:
      - source_labels: ['__name__']
        regex: '.*'
        action: replace
        target_label: 'datacentre'
        replacement: "{{ cluster.prometheus_datacentre }}"
      - source_labels: ['__name__']
        regex: '.*'
        action: replace
        target_label: 'job'
        replacement: "kubelet"

  - job_name: 'cadvisor-{{ cluster.prometheus_datacentre }}'
    kubernetes_sd_configs:
    - role: node
      api_server: "{{ cluster.api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: {{ cluster.client_certificate }}
      bearer_token_file: {{ cluster.bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      insecure_skip_verify: true
    bearer_token_file: {{ cluster.bearer_token }}
    metrics_path: /metrics/cadvisor
    relabel_configs:
      - source_labels: ['__name__']
        regex: '.*'
        action: replace
        target_label: 'datacentre'
        replacement: "{{ cluster.prometheus_datacentre }}"
      - source_labels: ['__name__']
        regex: '.*'
        action: replace
        target_label: 'job'
        replacement: "cadvisor"

{% endfor %}

{% endif %}